# llvm-dwarfdump - dump and verify DWARF debug information

## SYNOPSIS

llvm-dwarfdump [options] [filename …]

## DESCRIPTION

llvm-dwarfdump parses DWARF sections in object files, archives, and .dSYM bundles and prints their contents in human-readable form. Only the .debug_info section is printed unless one of the section-specific options or `--all` is specified.

## OPTIONS

`-a````,` `--all```

  Disassemble all supported DWARF sections.

`--arch``=<arch>`

  Dump DWARF debug information for the specified CPU architecture. Architectures may be specified by name or by number. This option can be specified multiple times, once for each desired architecture. All CPU architectures will be printed by default.

`-c````,` `--show-children```

  Show a debug info entry’s children when using the `--debug-info`, `--find`, and `--name` options.

`-f``<name>``,` `--find``=<name>`

  Search for the exact text <name> in the accelerator tables and print the matching debug information entries. When there is no accelerator tables or the name of the DIE you are looking for is not found in the accelerator tables, try using the slower but more complete `--name` option.

`-F````,` `--show-form```

  Show DWARF form types after the DWARF attribute types.

`-h````,` `--help```

  Show help and usage for this command.

`-i````,` `--ignore-case```

  Ignore case distinctions in when searching entries by name or by regular expression.

`-n``<pattern>``,` `--name``=<pattern>`

  Find and print all debug info entries whose name (DW_AT_name attribute) matches the exact text in <pattern>. Use the `--regex` option to have <pattern> become a regular expression for more flexible pattern matching.

`--lookup``=<address>`

  Lookup <address> in the debug information and print out the file, function, block, and line table details.

`-o``<path>``,` `--out-file``=<path>`

  Redirect output to a file specified by <path>.

`-p````,` `--show-parents```

  Show a debug info entry’s parent objects when using the `--debug-info`, `--find`, and `--name` options.

`-r``<n>``,` `--recurse-depth``=<n>`

  Only recurse to a maximum depth of <n> when dumping debug info entries.

`--statistics```

  Collect debug info quality metrics and print the results as machine-readable single-line JSON output.

`-x````,` `--regex```

  Treat any <pattern> strings as regular expressions when searching instead of just as an exact string match.

`-u````,` `--uuid```

  Show the UUID for each architecture.

`--diff```

  Dump the output in a format that is more friendly for comparing DWARF output from two different files.

`-v````,` `--verbose```

  Display verbose information when dumping. This can help to debug DWARF issues.

`--verify```

  Verify the structure of the DWARF information by verifying the compile unit chains, DIE relationships graph, address ranges, and more.

`--version```

  Display the version of the tool.

`--debug-abbrev````,` `--debug-aranges````,` `--debug-cu-index````,` `--debug-frame``[=<offset>]``,` `--debug-gnu-pubnames````,` `--debug-gnu-pubtypes````,` `--debug-info``[=<offset>]``,` `--debug-line``[=<offset>]``,` `--debug-loc``[=<offset>]``,` `--debug-macro````,` `--debug-pubnames````,` `--debug-pubtypes````,` `--debug-ranges````,` `--debug-str````,` `--debug-str-offsets````,` `--debug-tu-index````,` `--debug-types````,` `--eh-frame````,` `--gdb-index````,` `--apple-names````,` `--apple-types````,` `--apple-namespaces````,` `--apple-objc```

  Dump the specified DWARF section by name. Only the .debug_info section is shown by default. Some entries support adding an =<offset> as a way to provide an optional offset of the exact entry to dump within the respective section. When an offset is provided, only the entry at that offset will be dumped, else the entire section will be dumped. Children of items at a specific offset can be dumped by also using the `--show-children` option where applicable.

## EXIT STATUS

llvm-dwarfdump returns 0 if the input files were parsed and dumped successfully. Otherwise, it returns 1.

## SEE ALSO

dsymutil(1)